
/**
 * Questa classe dichiara tre diversi costruttori. I costruttori
 * racchiudono le operazioni che inizializzano le istanze
 * delle varie classi, ovvero gli oggetti.
 * Notate come in Java possano essere dichiarati diversi costruttori
 * per lo stesso oggetto. Il costruttore deve avere lo stesso nome della
 * classe e può prendere diversi parametri. Anzi: sono proprio i parametri
 * in input ai costruttori che ci permettono di definire diversi
 * costruttori. Quando creiamo un oggetto, a seconda dei parametri che
 * inseriamo nel costruttore, richiediamo l'esecuzione di un determinato
 * costruttore.
 * In questo esempio: se non passiamo alcun parametro, eseguiamo il
 * primo costruttore; se passiamo due stringhe, eseguiamo il secondo;
 * se passiamo due stringhe e un intero, eseguiamo il terzo.
 * Viene definito anche un metodo per modificare uno degli attributi
 * dell'oggetto Contatto.
 * Prestate particolarmente attenzione a tutti i "modificatori" degli
 * attributi e dei metodi. Sarete interrogati a lezione!!
 * 
 * 
 * @author (your name) Angelo
 * @version (a version number or a date) Marzo 2007
 */
public class Contatto
{
    private final String nomeContatto;
    private String email;
    private int numeroTelefonico;
    public static final String proprietarioContatto = "Angelo";

    /**
     * Constructor for objects of class Contatto
     */
 
    // costruttore nullo 
    public Contatto( )
    {
        this("", "", 0);
    }  

    // costruttore con 2 argomenti
    /**
    * @param nome Uno String corrispondente al nome del contatto
    * @param email Uno String corrispondente alla mail del contatto
    */

    public Contatto(String nome, String email)
    {
        nomeContatto = nome;
        this.email = email;
        
    }
    
   // costruttore con 3 argomenti
    /**
    * @param nome Uno String corrispondente al nome del contatto
    * @param email Uno String corrispondente alla mail del contatto
    * @param ntel Un int corrispondente al telefono del contatto
    */

   public Contatto(String nome, String email, int ntel)
    {
        nomeContatto = nome;
        this.email = email;
        numeroTelefonico =ntel;
    }
    
    public void stampaDatiContatto() {
        System.out.println("Nome contatto: " + nomeContatto);
        System.out.println("Email: " + email);
        System.out.println("Numero di tel: " + numeroTelefonico);
    }
    
    public void setNumeroTelefonico(int ntel){
        this.numeroTelefonico = ntel;   
    }
    
    public void provaChange() {
        LocalVariables l = new LocalVariables();
        l.changeValue(this);
        stampaDatiContatto();
        l.changeValueInt(numeroTelefonico);
        stampaDatiContatto();
    }
    
    // Main method
    public static void main(String[] args)
    {
        Contatto c1, c2, c3, c4, c5;
        System.out.println("Proprietario contatto: " + Contatto.proprietarioContatto);
        c1 = new Contatto();
        System.out.println("Proprietario contatto: " + c1.proprietarioContatto);
        c2 = new Contatto();
        c3 = new Contatto("Cristina Chiabotto", "missitalia2004@yahoo.zip");
        c4 = new Contatto("Edelfa Chiara Masciotta", "missitalia2005@yahoo.zip", 5557198);
        c5 = new Contatto("Claudia Andreatti", "missitalia2006@yahoo.zip",55565434);
        c5.stampaDatiContatto();

        c1.stampaDatiContatto();
        c1.setNumeroTelefonico(555323232);
        c1.stampaDatiContatto();
        c1.provaChange();
     
    }
   
}
